/**
 * @package         Modals
 * @version         12.1.0PRO
 * 
 * @author          Peter van Westen <info@regularlabs.com>
 * @link            http://regularlabs.com
 * @copyright       Copyright © 2023 Regular Labs All Rights Reserved
 * @license         http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

(function() {
    'use strict';

    window.RegularLabs        = window.RegularLabs || {};
    window.RegularLabs.Modals = window.RegularLabs.Modals || {};

    window.RegularLabs.Modals.Popup = window.RegularLabs.Modals.Popup || {
        form: null,

        init: function(editor_name) {
            if ( ! parent.RegularLabs.Modals.Button) {
                document.querySelector('body').innerHTML = '<div class="alert alert-error">This page cannot function on its own.</div>';
                return;
            }

            const content_editor = Joomla.editors.instances['content'];

            try {
                content_editor.getValue();
            } catch (err) {
                setTimeout(() => {
                    RegularLabs.Modals.Popup.init(editor_name);
                }, 100);
                return;
            }

            this.form         = document.getElementById('modalsForm');
            this.form.editors = Joomla.editors.instances;

            parent.RegularLabs.Modals.Button.setForm(this.form);
        }
    };
})();
